#ifndef __JABYENGINE_GPU_H__
#define __JABYENGINE_GPU_H__
#include "../System/IOPorts/GPU_IO.hpp"

namespace GPU {
    namespace Display {
        static void enable() {
            GP1.write(Command::GP1::SetDisplayState(DisplayState::On));
        }

        static void disable() {
            GP1.write(Command::GP1::SetDisplayState(DisplayState::Off));
        }
    }
}

#endif //!__JABYENGINE_GPU_H__